###############################
# STATISTICAL THINKINK (2020) #
###############################

# Title
print("Machine Learning and Quality of Wine")

# Packages for Datasets and Dataframes
import pandas as pd 

# Import Dataset
df_red = pd.read_csv("https://archive.ics.uci.edu/ml/machine-learning-databases/wine-quality/winequality-red.csv", sep=";")
df_red

# Descriptive Analysis
df_red.describe()

# Create Binary Dependent Variable (0 -> Bad Wine, 1 -> Good Wine)
import numpy as np
df_red["quality_bin"] = np.zeros(df_red.shape[0])
df_red["quality_bin"] = df_red["quality_bin"].where(df_red["quality"]>=6, 1)

# Checking new Dependent Variable
df_red.describe()

# Setting Dependent (Y) and Independent (X) Variables
X = df_red.iloc[:, :11]
Y = df_red.iloc[:, -1:]

# Splitting Dataset 
from sklearn.model_selection import train_test_split
x_train,x_test,y_train,y_test=train_test_split(X,Y,test_size=.3)

# Machine Learning Model (Logistic Regression)
from sklearn import linear_model
from sklearn.metrics import accuracy_score
lr = linear_model.LogisticRegression() 
lr.fit(x_train, y_train.values.ravel()) 
predictions=lr.predict(x_test)

# Accuracy of Machine Learning Model
print("Accuracy (non-standardized Data)")
print(accuracy_score(y_test,predictions))

# Another Approach with Standardized-Independent (X) Variables
from sklearn import preprocessing
X_standardized = preprocessing.scale(X)

# Splitting Dataset 
from sklearn.model_selection import train_test_split
x_train,x_test,y_train,y_test=train_test_split(X_standardized,Y,test_size=.3)

# Machine Learning Model (Logistic Regression)
from sklearn import linear_model
from sklearn.metrics import accuracy_score
lr = linear_model.LogisticRegression() 
lr.fit(x_train, y_train) 
predictions=lr.predict(x_test)

# Accuracy of Machine Learning Model
print("Accuracy (standardized Data)")
print(accuracy_score(y_test,predictions))